<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

JLoader::register('K2Plugin',JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'lib'.DS.'k2plugin.php');

class plgK2LinkItem extends K2Plugin {

	// Some params
	var $pluginName = 'linkitem';
	var $pluginNameHumanReadable = 'K2 Link item';

	function plgK2LinkItem(&$subject, $params) {
		parent::__construct($subject, $params);
	}

	function onK2BeforeDisplay( & $item, & $params, $limitstart) {
		global $mainframe;
		
		return '';
	}
	
	function onK2AfterDisplay( & $item, & $params, $limitstart) {
		global $mainframe;

		jimport('joomla.filesystem.file');
		
		$view=JRequest::getCmd('view');

		$user = & JFactory::getUser();
		
		$html = '';

		// if we're in the k2 item view
		if( $view == 'item') {
			$plugin = & JPluginHelper::getPlugin('k2', 'linkitem');
			$pluginParams = new JParameter($plugin->params);
	
			$pluginItemParams = $objectParams = $this->k2TOJParameter($item->plugins, $this->pluginName);
			$pluginParams->merge($pluginItemParams);
			
			$linkedItemId = $pluginParams->get('linkedItemId',0);

			if ($linkedItemId) {
				JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'tables');
				$linkedItem = & JTable::getInstance('K2Item', 'Table');
				$linkedItem->load($linkedItemId);
				
				if ($linkedItem->id) {
					//Category
					$category = & JTable::getInstance('K2Category', 'Table');
					$category->load($linkedItem->catid);

					if (($linkedItem->access <= $user->get('aid', 0)) && ($category->access <= $user->get('aid', 0))) {
						$linkedItem->category=$category;
						$linkedItem->category->link=urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($category->id.':'.urlencode($category->alias))));
							
						if($pluginParams->get('linkedItemImage',0)) {
							if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$linkedItem->id).'_'.$pluginParams->get('linkedItemImageSize').'.jpg'))
								$linkedItem->image = JURI::root().'media/k2/items/cache/'.md5("Image".$linkedItem->id).'_'.$pluginParams->get('linkedItemImageSize').'.jpg';
						}
						
						if($pluginParams->get('linkedItemLink',0)) {
							//Read more link
							$link = K2HelperRoute::getItemRoute($linkedItem->id.':'.urlencode($linkedItem->alias),$linkedItem->catid.':'.urlencode($linkedItem->category->alias));
							$linkedItem->link=urldecode(JRoute::_($link));
						}
						
						$document = &JFactory::getDocument();
					
						if($pluginParams->get('loadPluginCss',1) && JFile::exists(dirname(__FILE__).DS.'linkitem'.DS.'linkitem.css'))
							$document->addStyleSheet(JURI::root().'plugins/k2/linkitem/linkitem.css');
							
						if (JFile::exists(JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.'plg_k2_linkitem'.DS.'default.php'))
							$defaultFile = JPATH_SITE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.'plg_k2_linkitem'.DS.'default.php';
						else
							$defaultFile = dirname(__FILE__).DS.'linkitem'.DS.'default.php';
							
						ob_start();
						require_once($defaultFile);
						$output = ob_get_contents();
						ob_end_clean();
						$html = $output;
					}
				}
			}
		}

		return $html;
	}

	function onK2AfterDisplayTitle( & $item, & $params, $limitstart) {
		global $mainframe;
		return '';
	}

	function onK2BeforeDisplayContent( & $item, & $params, $limitstart) {
		global $mainframe;
		return '';
	}

	function onK2AfterDisplayContent( & $item, & $params, $limitstart) {
		global $mainframe;
		return '';
	}
	
	function onK2CategoryDisplay( & $category, & $params, $limitstart) {
		global $mainframe;
		
		return '';
	}

	function onK2UserDisplay( & $user, & $params, $limitstart) {

		global $mainframe;
		
		return '';
	}
	
	function k2TOJParameter($k2Plugins,$k2Plugin) {

		$k2Registry = new JRegistry();
		$k2Registry->loadINI($k2Plugins);
		$k2Array['plugins'] = $k2Registry->toArray();

		$jArray = array();

		foreach($k2Array['plugins'] as $k2Param => $k2Value) {
			$jArray[str_replace($k2Plugin,"",$k2Param)] = $k2Value;
		}
		$jRegistry = new JRegistry('_default');
		$jRegistry->loadArray($jArray);

		return $jRegistry;
	}
	
} // END CLASS
